diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/click/bindings/modulegen__gcc_LP64.py ns-3.35/src/click/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/click/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/click/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -1396,11 +1396,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsEqual(ns3::Ipv4Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1473,6 +1468,11 @@
     cls.add_constructor([param('ns3::Ipv4Address', 'local'), param('ns3::Ipv4Mask', 'mask')])
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4InterfaceAddress::Ipv4InterfaceAddress(ns3::Ipv4InterfaceAddress const & o) [constructor]
     cls.add_constructor([param('ns3::Ipv4InterfaceAddress const &', 'o')])
+    ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetAddress() const [member function]
+    cls.add_method('GetAddress', 
+                   'ns3::Ipv4Address', 
+                   [], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): ns3::Ipv4Address ns3::Ipv4InterfaceAddress::GetBroadcast() const [member function]
     cls.add_method('GetBroadcast', 
                    'ns3::Ipv4Address', 
@@ -1493,11 +1493,20 @@
                    'ns3::Ipv4InterfaceAddress::InterfaceAddressScope_e', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsInSameSubnet(ns3::Ipv4Address const b) const [member function]
+    cls.add_method('IsInSameSubnet', 
+                   'bool', 
+                   [param('ns3::Ipv4Address const', 'b')], 
+                   is_const=True)
     ## ipv4-interface-address.h (module 'internet'): bool ns3::Ipv4InterfaceAddress::IsSecondary() const [member function]
     cls.add_method('IsSecondary', 
                    'bool', 
                    [], 
                    is_const=True)
+    ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetAddress(ns3::Ipv4Address address) [member function]
+    cls.add_method('SetAddress', 
+                   'void', 
+                   [param('ns3::Ipv4Address', 'address')])
     ## ipv4-interface-address.h (module 'internet'): void ns3::Ipv4InterfaceAddress::SetBroadcast(ns3::Ipv4Address broadcast) [member function]
     cls.add_method('SetBroadcast', 
                    'void', 
@@ -1566,11 +1575,6 @@
                    'ns3::Ipv4Mask', 
                    [], 
                    is_static=True)
-    ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsEqual(ns3::Ipv4Mask other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv4Mask', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv4-address.h (module 'network'): bool ns3::Ipv4Mask::IsMatch(ns3::Ipv4Address a, ns3::Ipv4Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
@@ -1687,11 +1691,6 @@
                    'bool', 
                    [], 
                    is_const=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsEqual(ns3::Ipv6Address const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Address const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Address::IsInitialized() const [member function]
     cls.add_method('IsInitialized', 
                    'bool', 
@@ -1884,11 +1883,6 @@
                    'ns3::Ipv6Prefix', 
                    [], 
                    is_static=True)
-    ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsEqual(ns3::Ipv6Prefix const & other) const [member function]
-    cls.add_method('IsEqual', 
-                   'bool', 
-                   [param('ns3::Ipv6Prefix const &', 'other')], 
-                   deprecated=True, is_const=True)
     ## ipv6-address.h (module 'network'): bool ns3::Ipv6Prefix::IsMatch(ns3::Ipv6Address a, ns3::Ipv6Address b) const [member function]
     cls.add_method('IsMatch', 
                    'bool', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/bindings/modulegen__gcc_ILP32.py ns-3.35/src/config-store/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/config-store/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
@@ -38,8 +38,6 @@
     module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
     ## file-config.h (module 'config-store'): ns3::FileConfig [class]
     module.add_class('FileConfig', allow_subclassing=True)
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore [class]
-    module.add_class('GtkConfigStore')
     ## hash.h (module 'core'): ns3::Hasher [class]
     module.add_class('Hasher', import_from_module='ns.core')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -175,7 +173,6 @@
     register_Ns3DefaultDeleter__Ns3HashImplementation_methods(root_module, root_module['ns3::DefaultDeleter< ns3::Hash::Implementation >'])
     register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
     register_Ns3FileConfig_methods(root_module, root_module['ns3::FileConfig'])
-    register_Ns3GtkConfigStore_methods(root_module, root_module['ns3::GtkConfigStore'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3NoneFileConfig_methods(root_module, root_module['ns3::NoneFileConfig'])
@@ -324,21 +321,10 @@
                    'void', 
                    [param('std::string', 'filename')], 
                    is_pure_virtual=True, is_virtual=True)
-    return
-
-def register_Ns3GtkConfigStore_methods(root_module, cls):
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore::GtkConfigStore(ns3::GtkConfigStore const & arg0) [constructor]
-    cls.add_constructor([param('ns3::GtkConfigStore const &', 'arg0')])
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore::GtkConfigStore() [constructor]
-    cls.add_constructor([])
-    ## gtk-config-store.h (module 'config-store'): void ns3::GtkConfigStore::ConfigureAttributes() [member function]
-    cls.add_method('ConfigureAttributes', 
+    ## file-config.h (module 'config-store'): void ns3::FileConfig::SetSaveDeprecated(bool saveDeprecated) [member function]
+    cls.add_method('SetSaveDeprecated', 
                    'void', 
-                   [])
-    ## gtk-config-store.h (module 'config-store'): void ns3::GtkConfigStore::ConfigureDefaults() [member function]
-    cls.add_method('ConfigureDefaults', 
-                   'void', 
-                   [])
+                   [param('bool', 'saveDeprecated')])
     return
 
 def register_Ns3Hasher_methods(root_module, cls):
@@ -768,6 +754,10 @@
     cls.add_method('SetMode', 
                    'void', 
                    [param('ns3::ConfigStore::Mode', 'mode')])
+    ## config-store.h (module 'config-store'): void ns3::ConfigStore::SetSaveDeprecated(bool saveDeprecated) [member function]
+    cls.add_method('SetSaveDeprecated', 
+                   'void', 
+                   [param('bool', 'saveDeprecated')])
     return
 
 def register_Ns3SimpleRefCount__Ns3AttributeAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeAccessor__gt___methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/bindings/modulegen__gcc_LP64.py ns-3.35/src/config-store/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/config-store/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -38,8 +38,6 @@
     module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
     ## file-config.h (module 'config-store'): ns3::FileConfig [class]
     module.add_class('FileConfig', allow_subclassing=True)
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore [class]
-    module.add_class('GtkConfigStore')
     ## hash.h (module 'core'): ns3::Hasher [class]
     module.add_class('Hasher', import_from_module='ns.core')
     ## log.h (module 'core'): ns3::LogComponent [class]
@@ -175,7 +173,6 @@
     register_Ns3DefaultDeleter__Ns3HashImplementation_methods(root_module, root_module['ns3::DefaultDeleter< ns3::Hash::Implementation >'])
     register_Ns3DefaultDeleter__Ns3TraceSourceAccessor_methods(root_module, root_module['ns3::DefaultDeleter< ns3::TraceSourceAccessor >'])
     register_Ns3FileConfig_methods(root_module, root_module['ns3::FileConfig'])
-    register_Ns3GtkConfigStore_methods(root_module, root_module['ns3::GtkConfigStore'])
     register_Ns3Hasher_methods(root_module, root_module['ns3::Hasher'])
     register_Ns3LogComponent_methods(root_module, root_module['ns3::LogComponent'])
     register_Ns3NoneFileConfig_methods(root_module, root_module['ns3::NoneFileConfig'])
@@ -324,21 +321,10 @@
                    'void', 
                    [param('std::string', 'filename')], 
                    is_pure_virtual=True, is_virtual=True)
-    return
-
-def register_Ns3GtkConfigStore_methods(root_module, cls):
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore::GtkConfigStore(ns3::GtkConfigStore const & arg0) [constructor]
-    cls.add_constructor([param('ns3::GtkConfigStore const &', 'arg0')])
-    ## gtk-config-store.h (module 'config-store'): ns3::GtkConfigStore::GtkConfigStore() [constructor]
-    cls.add_constructor([])
-    ## gtk-config-store.h (module 'config-store'): void ns3::GtkConfigStore::ConfigureAttributes() [member function]
-    cls.add_method('ConfigureAttributes', 
+    ## file-config.h (module 'config-store'): void ns3::FileConfig::SetSaveDeprecated(bool saveDeprecated) [member function]
+    cls.add_method('SetSaveDeprecated', 
                    'void', 
-                   [])
-    ## gtk-config-store.h (module 'config-store'): void ns3::GtkConfigStore::ConfigureDefaults() [member function]
-    cls.add_method('ConfigureDefaults', 
-                   'void', 
-                   [])
+                   [param('bool', 'saveDeprecated')])
     return
 
 def register_Ns3Hasher_methods(root_module, cls):
@@ -768,6 +754,10 @@
     cls.add_method('SetMode', 
                    'void', 
                    [param('ns3::ConfigStore::Mode', 'mode')])
+    ## config-store.h (module 'config-store'): void ns3::ConfigStore::SetSaveDeprecated(bool saveDeprecated) [member function]
+    cls.add_method('SetSaveDeprecated', 
+                   'void', 
+                   [param('bool', 'saveDeprecated')])
     return
 
 def register_Ns3SimpleRefCount__Ns3AttributeAccessor_Ns3Empty_Ns3DefaultDeleter__lt__ns3AttributeAccessor__gt___methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/config-store.cc ns-3.35/src/config-store/model/config-store.cc
--- ns-3.34/src/config-store/model/config-store.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/config-store.cc	2021-10-01 13:26:47.000000000 -0700
@@ -26,6 +26,7 @@
 #include "ns3/simulator.h"
 #include "ns3/attribute-construction-list.h"
 #include "ns3/enum.h"
+#include "ns3/boolean.h"
 #include "ns3/config-store-config.h"
 #ifdef HAVE_LIBXML2
 #include "xml-config.h"
@@ -68,6 +69,11 @@
                    MakeEnumAccessor (&ConfigStore::SetFileFormat),
                    MakeEnumChecker (ConfigStore::RAW_TEXT, "RawText",
                                     ConfigStore::XML, "Xml"))
+    .AddAttribute ("SaveDeprecated",
+                   "Save DEPRECATED attributes",
+                   BooleanValue (true),
+                   MakeBooleanAccessor (&ConfigStore::SetSaveDeprecated),
+                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -129,6 +135,8 @@
         }
     }
   m_file->SetFilename (m_filename);
+  m_file->SetSaveDeprecated (m_saveDeprecated);
+
   NS_LOG_FUNCTION (this << ": format: " << m_fileFormat
                 << ", mode: " << m_mode
                 << ", file name: " << m_filename);
@@ -159,6 +167,12 @@
   NS_LOG_FUNCTION (this << filename);
   m_filename = filename;
 }
+void
+ConfigStore::SetSaveDeprecated (bool saveDeprecated)
+{
+  NS_LOG_FUNCTION (this << saveDeprecated);
+  m_saveDeprecated = saveDeprecated;
+}
 
 void 
 ConfigStore::ConfigureAttributes (void)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/config-store.h ns-3.35/src/config-store/model/config-store.h
--- ns-3.34/src/config-store/model/config-store.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/config-store.h	2021-10-01 13:26:47.000000000 -0700
@@ -103,6 +103,11 @@
    * \param filename the file name
    */
   void SetFilename (std::string filename);
+  /**
+   * Set if to save deprecated attributes
+   * \param saveDeprecated the deprecated attributes save policy
+   */
+  void SetSaveDeprecated (bool saveDeprecated);
 
   /**
    * Configure the default values
@@ -116,6 +121,7 @@
 private:
   enum Mode m_mode; ///< store mode
   enum FileFormat m_fileFormat; ///< store format
+  bool m_saveDeprecated; ///< save deprecated attributes
   std::string m_filename; ///< store file name
   FileConfig *m_file; ///< configuration file
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/file-config.cc ns-3.35/src/config-store/model/file-config.cc
--- ns-3.34/src/config-store/model/file-config.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/file-config.cc	2021-10-01 13:26:47.000000000 -0700
@@ -26,6 +26,12 @@
 {
 }
 
+void
+FileConfig::SetSaveDeprecated (bool saveDeprecated)
+{
+  m_saveDeprecated = saveDeprecated;
+}
+
 NoneFileConfig::NoneFileConfig ()
 {
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/file-config.h ns-3.35/src/config-store/model/file-config.h
--- ns-3.34/src/config-store/model/file-config.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/file-config.h	2021-10-01 13:26:47.000000000 -0700
@@ -40,6 +40,11 @@
    */
   virtual void SetFilename (std::string filename) = 0;
   /**
+   * Set if to save deprecated attributes
+   * \param saveDeprecated the deprecated attributes save policy
+   */
+  void SetSaveDeprecated (bool saveDeprecated);
+  /**
    * Load or save the default values
    */
   virtual void Default (void) = 0;
@@ -51,6 +56,9 @@
    * Load or save the attributes values
    */
   virtual void Attributes (void) = 0;
+
+protected:
+  bool m_saveDeprecated; ///< save deprecated attributes
 };
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/raw-text-config.cc ns-3.35/src/config-store/model/raw-text-config.cc
--- ns-3.34/src/config-store/model/raw-text-config.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/raw-text-config.cc	2021-10-01 13:26:47.000000000 -0700
@@ -67,19 +67,51 @@
     RawTextDefaultIterator (std::ostream *os) {
       m_os = os;
     }
+    void SetSaveDeprecated (bool saveDeprecated) {
+      m_saveDeprecated = saveDeprecated;
+    }
+
 private:
     virtual void StartVisitTypeId (std::string name) {
       m_typeId = name;
     }
     virtual void DoVisitAttribute (std::string name, std::string defaultValue) {
       NS_LOG_DEBUG ("Saving " << m_typeId << "::" << name);
-      *m_os << "default " << m_typeId << "::" << name << " \"" << defaultValue << "\"" << std::endl;
-    }
+      TypeId tid = TypeId::LookupByName (m_typeId);
+      ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
+      for (std::size_t i = 0; i < tid.GetAttributeN (); i++)
+        {
+          struct TypeId::AttributeInformation tmp = tid.GetAttribute (i);
+          if (tmp.name == name)
+            {
+              supportLevel = tmp.supportLevel;
+              break;
+            }
+        }
+      if (supportLevel == TypeId::SupportLevel::OBSOLETE)
+        {
+          NS_LOG_WARN ("Global attribute "
+                       << m_typeId << "::" << name
+                       << " was not saved because it is OBSOLETE");
+        }
+      else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) && (m_saveDeprecated == false))
+        {
+          NS_LOG_WARN ("Global attribute " << m_typeId << "::" << name
+                                           << " was not saved because it is DEPRECATED");
+        }
+      else
+        {
+          *m_os << "default " << m_typeId << "::" << name << " \"" << defaultValue << "\""
+                << std::endl;
+        }
+      }
     std::string m_typeId;
     std::ostream *m_os;
+    bool m_saveDeprecated;
   };
 
   RawTextDefaultIterator iterator = RawTextDefaultIterator (m_os);
+  iterator.SetSaveDeprecated (m_saveDeprecated);
   iterator.Iterate ();
 }
 void
@@ -103,17 +135,50 @@
 public:
     RawTextAttributeIterator (std::ostream *os)
       : m_os (os) {}
+    void
+    SetSaveDeprecated (bool saveDeprecated) {
+      m_saveDeprecated = saveDeprecated;
+    }
+
 private:
     virtual void DoVisitAttribute (Ptr<Object> object, std::string name) {
       StringValue str;
-      object->GetAttribute (name, str);
-      NS_LOG_DEBUG ("Saving " << GetCurrentPath ());
-      *m_os << "value " << GetCurrentPath () << " \"" << str.Get () << "\"" << std::endl;
+
+      ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
+      TypeId tid = object->GetInstanceTypeId ();
+
+      for (std::size_t i = 0; i < tid.GetAttributeN (); i++)
+        {
+          struct TypeId::AttributeInformation tmp = tid.GetAttribute (i);
+          if (tmp.name == name)
+            {
+              supportLevel = tmp.supportLevel;
+              break;
+            }
+        }
+      if (supportLevel == TypeId::SupportLevel::OBSOLETE)
+        {
+          NS_LOG_WARN ("Attribute " << GetCurrentPath ()
+                                    << " was not saved because it is OBSOLETE");
+        }
+      else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) && (m_saveDeprecated == false))
+        {
+          NS_LOG_WARN ("Attribute " << GetCurrentPath ()
+                                    << " was not saved because it is DEPRECATED");
+        }
+      else
+        {
+          object->GetAttribute (name, str);
+          NS_LOG_DEBUG ("Saving " << GetCurrentPath ());
+          *m_os << "value " << GetCurrentPath () << " \"" << str.Get () << "\"" << std::endl;
+        }
     }
     std::ostream *m_os;
+    bool m_saveDeprecated;
   };
 
   RawTextAttributeIterator iter = RawTextAttributeIterator (m_os);
+  iter.SetSaveDeprecated (m_saveDeprecated);
   iter.Iterate ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/config-store/model/xml-config.cc ns-3.35/src/config-store/model/xml-config.cc
--- ns-3.34/src/config-store/model/xml-config.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/config-store/model/xml-config.cc	2021-10-01 13:26:47.000000000 -0700
@@ -106,12 +106,43 @@
     XmlDefaultIterator (xmlTextWriterPtr writer) {
       m_writer = writer;
     }
+    void
+    SetSaveDeprecated (bool saveDeprecated)
+    {
+      m_saveDeprecated = saveDeprecated;
+    }
+
 private:
     virtual void StartVisitTypeId (std::string name) {
       m_typeid = name;
     }
     virtual void DoVisitAttribute (std::string name, std::string defaultValue) {
-      int rc;
+      TypeId tid = TypeId::LookupByName (m_typeid);
+      ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
+      for (std::size_t i = 0; i < tid.GetAttributeN (); i++)
+        {
+          struct TypeId::AttributeInformation tmp = tid.GetAttribute (i);
+          if (tmp.name == name)
+            {
+              supportLevel = tmp.supportLevel;
+              break;
+            }
+        }
+      if (supportLevel == TypeId::SupportLevel::OBSOLETE)
+        {
+          NS_LOG_WARN ("Global attribute "
+                       << m_typeid << "::" << name
+                       << " was not saved because it is OBSOLETE");
+          return;
+        }
+      else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) && (m_saveDeprecated == false))
+        {
+          NS_LOG_WARN ("Global attribute " << m_typeid << "::" << name
+                                           << " was not saved because it is DEPRECATED");
+          return;
+        }
+
+        int rc;
       rc = xmlTextWriterStartElement (m_writer, BAD_CAST "default");
       if (rc < 0)
         {
@@ -138,8 +169,10 @@
     }
     xmlTextWriterPtr m_writer;
     std::string m_typeid;
+    bool m_saveDeprecated;
   };
   XmlDefaultIterator iterator = XmlDefaultIterator (m_writer);
+  iterator.SetSaveDeprecated (m_saveDeprecated);
   iterator.Iterate ();
 }
 
@@ -151,8 +184,37 @@
 public:
     XmlTextAttributeIterator (xmlTextWriterPtr writer)
       : m_writer (writer) {}
-private:
+    void
+    SetSaveDeprecated (bool saveDeprecated)
+    {
+      m_saveDeprecated = saveDeprecated;
+    }
+
+  private:
     virtual void DoVisitAttribute (Ptr<Object> object, std::string name) {
+      TypeId tid = object->GetInstanceTypeId ();
+      ns3::TypeId::SupportLevel supportLevel = TypeId::SupportLevel::SUPPORTED;
+      for (std::size_t i = 0; i < tid.GetAttributeN (); i++)
+        {
+          struct TypeId::AttributeInformation tmp = tid.GetAttribute (i);
+          if (tmp.name == name)
+            {
+              supportLevel = tmp.supportLevel;
+              break;
+            }
+        }
+      if (supportLevel == TypeId::SupportLevel::OBSOLETE)
+        {
+          NS_LOG_WARN ("Attribute " << GetCurrentPath ()
+                                    << " was not saved because it is OBSOLETE");
+          return;
+        }
+      else if ((supportLevel == TypeId::SupportLevel::DEPRECATED) && (m_saveDeprecated == false))
+        {
+          NS_LOG_WARN ("Attribute " << GetCurrentPath ()
+                                    << " was not saved because it is DEPRECATED");
+          return;
+        }
       StringValue str;
       object->GetAttribute (name, str);
       int rc;
@@ -180,9 +242,11 @@
         }
     }
     xmlTextWriterPtr m_writer;
+    bool m_saveDeprecated;
   };
 
   XmlTextAttributeIterator iter = XmlTextAttributeIterator (m_writer);
+  iter.SetSaveDeprecated (m_saveDeprecated);
   iter.Iterate ();
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/core/bindings/modulegen__gcc_ILP32.py ns-3.35/src/core/bindings/modulegen__gcc_ILP32.py
--- ns-3.34/src/core/bindings/modulegen__gcc_ILP32.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/core/bindings/modulegen__gcc_ILP32.py	2021-10-01 13:26:47.000000000 -0700
@@ -2395,6 +2395,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector2D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector2D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector2D::y [variable]
@@ -2422,6 +2427,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector3D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector3D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector3D::y [variable]
@@ -5450,6 +5460,14 @@
     module.add_function('CalculateDistance', 
                         'double', 
                         [param('ns3::Vector3D const &', 'a'), param('ns3::Vector3D const &', 'b')])
+    ## vector.h (module 'core'): double ns3::CalculateDistanceSquared(ns3::Vector2D const & a, ns3::Vector2D const & b) [free function]
+    module.add_function('CalculateDistanceSquared', 
+                        'double', 
+                        [param('ns3::Vector2D const &', 'a'), param('ns3::Vector2D const &', 'b')])
+    ## vector.h (module 'core'): double ns3::CalculateDistanceSquared(ns3::Vector3D const & a, ns3::Vector3D const & b) [free function]
+    module.add_function('CalculateDistanceSquared', 
+                        'double', 
+                        [param('ns3::Vector3D const &', 'a'), param('ns3::Vector3D const &', 'b')])
     ## length.h (module 'core'): ns3::Length ns3::CentiMeters(double value) [free function]
     module.add_function('CentiMeters', 
                         'ns3::Length', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/core/bindings/modulegen__gcc_LP64.py ns-3.35/src/core/bindings/modulegen__gcc_LP64.py
--- ns-3.34/src/core/bindings/modulegen__gcc_LP64.py	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/core/bindings/modulegen__gcc_LP64.py	2021-10-01 13:26:47.000000000 -0700
@@ -2395,6 +2395,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector2D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector2D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector2D::y [variable]
@@ -2422,6 +2427,11 @@
                    'double', 
                    [], 
                    is_const=True)
+    ## vector.h (module 'core'): double ns3::Vector3D::GetLengthSquared() const [member function]
+    cls.add_method('GetLengthSquared', 
+                   'double', 
+                   [], 
+                   is_const=True)
     ## vector.h (module 'core'): ns3::Vector3D::x [variable]
     cls.add_instance_attribute('x', 'double', is_const=False)
     ## vector.h (module 'core'): ns3::Vector3D::y [variable]
@@ -5450,6 +5460,14 @@
     module.add_function('CalculateDistance', 
                         'double', 
                         [param('ns3::Vector3D const &', 'a'), param('ns3::Vector3D const &', 'b')])
+    ## vector.h (module 'core'): double ns3::CalculateDistanceSquared(ns3::Vector2D const & a, ns3::Vector2D const & b) [free function]
+    module.add_function('CalculateDistanceSquared', 
+                        'double', 
+                        [param('ns3::Vector2D const &', 'a'), param('ns3::Vector2D const &', 'b')])
+    ## vector.h (module 'core'): double ns3::CalculateDistanceSquared(ns3::Vector3D const & a, ns3::Vector3D const & b) [free function]
+    module.add_function('CalculateDistanceSquared', 
+                        'double', 
+                        [param('ns3::Vector3D const &', 'a'), param('ns3::Vector3D const &', 'b')])
     ## length.h (module 'core'): ns3::Length ns3::CentiMeters(double value) [free function]
     module.add_function('CentiMeters', 
                         'ns3::Length', 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/core/model/deprecated.h ns-3.35/src/core/model/deprecated.h
--- ns-3.34/src/core/model/deprecated.h	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/core/model/deprecated.h	2021-10-01 13:26:47.000000000 -0700
@@ -64,38 +64,20 @@
 
 /**
  * \ingroup core
- * \def NS_DEPRECATED_3_34
- * Tag for things deprecated in version ns-3.34.
- */
-#ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_34 NS_DEPRECATED
-#endif
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_32
- * Tag for things deprecated in version ns-3.32.
+ * \def NS_DEPRECATED_3_35
+ * Tag for things deprecated in version ns-3.35.
  */
 #ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_32 NS_DEPRECATED
+#define NS_DEPRECATED_3_35 NS_DEPRECATED
 #endif
 
 /**
  * \ingroup core
- * \def NS_DEPRECATED_3_31
- * Tag for things deprecated in version ns-3.31.
- */
-#ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_31 NS_DEPRECATED
-#endif
-
-/**
- * \ingroup core
- * \def NS_DEPRECATED_3_30
- * Tag for things deprecated in version ns-3.30.
+ * \def NS_DEPRECATED_3_34
+ * Tag for things deprecated in version ns-3.34.
  */
 #ifdef NS_DEPRECATED
-#define NS_DEPRECATED_3_30 NS_DEPRECATED
+#define NS_DEPRECATED_3_34 NS_DEPRECATED
 #endif
 
 #endif /* NS3_DEPRECATED_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.34/src/core/model/enum.cc ns-3.35/src/core/model/enum.cc
--- ns-3.34/src/core/model/enum.cc	2021-07-14 10:31:06.000000000 -0700
+++ ns-3.35/src/core/model/enum.cc	2021-10-01 13:26:47.000000000 -0700
@@ -22,6 +22,7 @@
 #include "log.h"
 #include <algorithm>  // find_if
 #include <sstream>
+#include <numeric> // std::accumulate
 
 /**
  * \file
@@ -112,7 +113,17 @@
   auto it = std::find_if (m_valueSet.begin (), m_valueSet.end (),
                           [name] (Value v) { return v.second == name; } );
   NS_ASSERT_MSG (it != m_valueSet.end (),
-                 "name " << name << " not a valid enum value. Missed entry in MakeEnumChecker?");
+                 "name " << name << " is not a valid enum value. Missed entry in MakeEnumChecker?\nAvailable values: " <<
+                 std::accumulate (m_valueSet.begin (), m_valueSet.end (), std::string{}, [](std::string a, Value v) {
+                   if (a.empty ())
+                     {
+                       return v.second;
+                     }
+                   else
+                     {
+                       return std::move (a) + ", " + v.second;
+                     }
+                 }));
   return it->first;
 }
 bool
